package com.ims.eval.service.impl;

import com.ims.eval.entity.EvaluationPortal;
import com.ims.eval.dao.EvaluationPortalMapper;
import com.ims.eval.service.IEvaluationPortalService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import groovy.util.logging.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 * 考评首页 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-05-10
 */
@Slf4j
@Service
public class EvaluationPortalServiceImpl extends ServiceImpl<EvaluationPortalMapper, EvaluationPortal> implements IEvaluationPortalService {

	@Override
	public Map<String, Object> getPortalData(String binSection, String year, String season) {
		Map<String, Object> map = new HashMap<>();
		Calendar date = Calendar.getInstance();
		try{
			List<Map<String, Object>> yearList = baseMapper.selectPortalList(binSection, date.get(Calendar.YEAR) == Integer.valueOf(year) ? String.valueOf(Integer.valueOf(year) - 1) : year, null);
			List<Map<String, Object>> seasonList = baseMapper.selectPortalList(binSection, year, season);
			Map<Object, List<Map<String, Object>>> yearMap = yearList.stream().collect(Collectors.groupingBy(e -> e.get("bin_section"), Collectors.toList()));
			Map<Object, List<Map<String, Object>>> seasonMap = seasonList.stream().collect(Collectors.groupingBy(e -> e.get("bin_section"), Collectors.toList()));
			map.put("year", yearMap);
			map.put("season", seasonMap);
		} catch (Exception e){
			log.error(e.getMessage());
		}

		return map;
	}
}
